#!/usr/bin/env ruby
# coding: utf-8

require 'open-uri'
require 'nokogiri'
require 'erb'

class Event
  attr_accessor :data, :url

  def initialize data, url
    @data = data
    @url = url
  end
end

events = []

url = "https://www.dhmd.de/veranstaltungen/kalender/1/"
doc = Nokogiri::HTML URI.open(url)
doc.css("a.more").each do |details_link|
  event_url = URI.join url, details_link.attr('href')
  details = Nokogiri::HTML URI.open(event_url)
  details.css("a.icon-termin").each do |icon|
    ical = URI.open(icon.attr('href')).read()
    ical.scan(/BEGIN:VEVENT\r\n(.+?)\nEND:VEVENT/m).each do |ev,|
      ev = Event::new ev, event_url
      events << ev
    end
  end
end

ical = ERB::new <<~EOF
  BEGIN:VCALENDAR
  VERSION:2.0
  METHOD:PUBLISH
  X-WR-TIMEZONE;VALUE=TEXT:Europe/Berlin
  <% events.each do |ev| %>
  BEGIN:VEVENT
  <%= ev.data %>
  URL:<%= ev.url %>
  LOCATION:Hygienemuseum
  END:VEVENT
  <% end %>
  END:VCALENDAR
EOF

puts ical.result
